Index: trunk/src/org/openstreetmap/josm/gui/history/AdjustmentSynchronizer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/AdjustmentSynchronizer.java	(revision 2165)
+++ trunk/src/org/openstreetmap/josm/gui/history/AdjustmentSynchronizer.java	(revision 2181)
@@ -76,8 +76,8 @@
     protected void setParticipatingInSynchronizedScrolling(Adjustable adjustable, boolean isParticipating) {
         if (adjustable == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "adjustable"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "adjustable"));
 
         if (! synchronizedAdjustables.contains(adjustable))
-            throw new IllegalStateException(tr("adjustable {0} not registered yet. Can't set participation in synchronized adjustment",adjustable));
+            throw new IllegalStateException(tr("Adjustable {0} not registered yet. Can't set participation in synchronized adjustment.", adjustable));
 
         enabledMap.put(adjustable, isParticipating);
@@ -94,5 +94,5 @@
     protected boolean isParticipatingInSynchronizedScrolling(Adjustable adjustable) throws IllegalStateException {
         if (! synchronizedAdjustables.contains(adjustable))
-            throw new IllegalStateException(tr("adjustable {0} not registered yet",adjustable));
+            throw new IllegalStateException(tr("Adjustable {0} not registered yet.", adjustable));
 
         return enabledMap.get(adjustable);
@@ -117,7 +117,7 @@
     protected void adapt(final JCheckBox view, final Adjustable adjustable) throws IllegalArgumentException, IllegalStateException {
         if (adjustable == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "adjustable"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "adjustable"));
         if (view == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "view"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "view"));
 
         if (! synchronizedAdjustables.contains(adjustable)) {
Index: trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowserModel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowserModel.java	(revision 2165)
+++ trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowserModel.java	(revision 2181)
@@ -140,5 +140,5 @@
     public TagTableModel getTagTableModel(PointInTimeType pointInTimeType) throws IllegalArgumentException {
         if (pointInTimeType == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "pointInTimeType"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "pointInTimeType"));
         if (pointInTimeType.equals(PointInTimeType.CURRENT_POINT_IN_TIME))
             return currentTagTableModel;
@@ -152,5 +152,5 @@
     public NodeListTableModel getNodeListTableModel(PointInTimeType pointInTimeType) throws IllegalArgumentException {
         if (pointInTimeType == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "pointInTimeType"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "pointInTimeType"));
         if (pointInTimeType.equals(PointInTimeType.CURRENT_POINT_IN_TIME))
             return currentNodeListTableModel;
@@ -164,5 +164,5 @@
     public RelationMemberTableModel getRelationMemberTableModel(PointInTimeType pointInTimeType) throws IllegalArgumentException {
         if (pointInTimeType == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "pointInTimeType"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "pointInTimeType"));
         if (pointInTimeType.equals(PointInTimeType.CURRENT_POINT_IN_TIME))
             return currentRelationMemberTableModel;
@@ -176,12 +176,12 @@
     public void setReferencePointInTime(HistoryOsmPrimitive reference) throws IllegalArgumentException, IllegalStateException{
         if (reference == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "reference"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "reference"));
         if (history == null)
-            throw new IllegalStateException(tr("history not initialized yet. Failed to set reference primitive."));
+            throw new IllegalStateException(tr("History not initialized yet. Failed to set reference primitive."));
         if (reference.getId() != history.getId())
-            throw new IllegalArgumentException(tr("failed to set reference. reference id {0} doesn't match history id {1}", reference.getId(),  history.getId()));
+            throw new IllegalArgumentException(tr("Failed to set reference. Reference ID {0} does not match history ID {1}.", reference.getId(),  history.getId()));
         HistoryOsmPrimitive primitive = history.getByVersion(reference.getVersion());
         if (primitive == null)
-            throw new IllegalArgumentException(tr("failed to set reference. reference version {0} not available in history", reference.getVersion()));
+            throw new IllegalArgumentException(tr("Failed to set reference. Reference version {0} not available in history.", reference.getVersion()));
 
         this.reference = reference;
@@ -195,12 +195,12 @@
     public void setCurrentPointInTime(HistoryOsmPrimitive current) throws IllegalArgumentException, IllegalStateException{
         if (current == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "current"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "current"));
         if (history == null)
-            throw new IllegalStateException(tr("history not initialized yet. Failed to set current primitive."));
+            throw new IllegalStateException(tr("History not initialized yet. Failed to set current primitive."));
         if (current.getId() != history.getId())
-            throw new IllegalArgumentException(tr("failed to set reference. reference id {0} doesn't match history id {1}", current.getId(),  history.getId()));
+            throw new IllegalArgumentException(tr("Hailed to set reference. Reference ID {0} does not match history ID {1}.", current.getId(),  history.getId()));
         HistoryOsmPrimitive primitive = history.getByVersion(current.getVersion());
         if (primitive == null)
-            throw new IllegalArgumentException(tr("failed to set current. current version {0} not available in history", current.getVersion()));
+            throw new IllegalArgumentException(tr("Failed to set current primitive. Current version {0} not available in history.", current.getVersion()));
         this.current = current;
         initTagTableModels();
@@ -238,5 +238,5 @@
     public HistoryOsmPrimitive getPointInTime(PointInTimeType type) throws IllegalArgumentException  {
         if (type == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "type"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "type"));
         if (type.equals(PointInTimeType.CURRENT_POINT_IN_TIME))
             return current;
Index: trunk/src/org/openstreetmap/josm/gui/history/HistoryLoadTask.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/HistoryLoadTask.java	(revision 2165)
+++ trunk/src/org/openstreetmap/josm/gui/history/HistoryLoadTask.java	(revision 2181)
@@ -38,7 +38,7 @@
     public HistoryLoadTask add(long id, OsmPrimitiveType type) {
         if (id <= 0)
-            throw new IllegalArgumentException(tr("id > 0 expected, got {0}", id));
+            throw new IllegalArgumentException(tr("ID > 0 expected. Got {0}.", id));
         if (type == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "type"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "type"));
         if (!toLoad.containsKey(id)) {
             toLoad.put(id, type);
@@ -49,5 +49,5 @@
     public HistoryLoadTask add(HistoryOsmPrimitive primitive) {
         if (primitive == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "primitive"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "primitive"));
         if (!toLoad.containsKey(primitive.getId())) {
             toLoad.put(primitive.getId(), primitive.getType());
@@ -58,5 +58,5 @@
     public HistoryLoadTask add(History history) {
         if (history == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "history"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "history"));
         if (!toLoad.containsKey(history.getId())) {
             toLoad.put(history.getId(), history.getEarliest().getType());
@@ -67,5 +67,5 @@
     public HistoryLoadTask add(OsmPrimitive primitive) {
         if (primitive == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "primitive"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "primitive"));
         return add(primitive.getId(), OsmPrimitiveType.from(primitive));
     }
@@ -73,5 +73,5 @@
     public HistoryLoadTask add(Collection<? extends OsmPrimitive> primitives) {
         if (primitives == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "primitives"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "primitives"));
         for (OsmPrimitive primitive: primitives) {
             if (primitive == null) {
Index: trunk/src/org/openstreetmap/josm/gui/history/VersionInfoPanel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/VersionInfoPanel.java	(revision 2165)
+++ trunk/src/org/openstreetmap/josm/gui/history/VersionInfoPanel.java	(revision 2181)
@@ -74,7 +74,7 @@
     public VersionInfoPanel(HistoryBrowserModel model, PointInTimeType pointInTimeType) throws IllegalArgumentException {
         if (pointInTimeType == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "pointInTimeType"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "pointInTimeType"));
         if (model == null)
-            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "model"));
+            throw new IllegalArgumentException(tr("Parameter ''{0}'' must not be null.", "model"));
 
         this.model = model;