Index: trunk/src/org/openstreetmap/josm/command/Command.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/Command.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/Command.java	(revision 2512)
@@ -21,5 +21,4 @@
 import org.openstreetmap.josm.gui.layer.Layer;
 import org.openstreetmap.josm.gui.layer.OsmDataLayer;
-
 
 /**
@@ -151,5 +150,3 @@
     abstract public MutableTreeNode description();
 
-
-
 }
Index: trunk/src/org/openstreetmap/josm/command/ConflictAddCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/ConflictAddCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/ConflictAddCommand.java	(revision 2512)
Index: trunk/src/org/openstreetmap/josm/command/ConflictResolveCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/ConflictResolveCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/ConflictResolveCommand.java	(revision 2512)
@@ -14,5 +14,5 @@
  * This is the common base class for {@see Command}s which manipulate {@see Conflict}s in
  * addition to {@see OsmPrimitive}s.
- * 
+ *
  * A ConflictResolverCommand can remember a collection of conflicts it resolves. Upon undoing
  * it reconstitutes them.
@@ -37,5 +37,5 @@
     /**
      * remembers a conflict in the internal list of remembered conflicts
-     * 
+     *
      * @param c the remembered conflict
      */
@@ -49,5 +49,5 @@
      * reconstitutes all remembered conflicts. Add the remembered conflicts to the
      * set of conflicts of the {@see OsmDataLayer} this command was applied to.
-     * 
+     *
      */
     protected void reconstituteConflicts() {
Index: trunk/src/org/openstreetmap/josm/command/CoordinateConflictResolveCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/CoordinateConflictResolveCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/CoordinateConflictResolveCommand.java	(revision 2512)
@@ -30,5 +30,5 @@
     /**
      * constructor
-     * 
+     *
      * @param my  my node
      * @param their  their node
@@ -39,5 +39,4 @@
         this.decision = decision;
     }
-
 
     @Override
Index: trunk/src/org/openstreetmap/josm/command/DeleteCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/DeleteCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/DeleteCommand.java	(revision 2512)
@@ -50,5 +50,5 @@
     /**
      * Constructor. Deletes a collection of primitives in the current edit layer.
-     * 
+     *
      * @param data the primitives to delete. Must neither be null nor empty.
      * @throws IllegalArgumentException thrown if data is null or empty
@@ -64,5 +64,5 @@
     /**
      * Constructor. Deletes a single primitive in the current edit layer.
-     * 
+     *
      * @param data  the primitive to delete. Must not be null.
      * @throws IllegalArgumentException thrown if data is null
Index: trunk/src/org/openstreetmap/josm/command/DeletedStateConflictResolveCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/DeletedStateConflictResolveCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/DeletedStateConflictResolveCommand.java	(revision 2512)
@@ -30,5 +30,5 @@
     /**
      * constructor
-     * 
+     *
      * @param my  my node
      * @param their  their node
@@ -39,5 +39,4 @@
         this.decision = decision;
     }
-
 
     @Override
Index: trunk/src/org/openstreetmap/josm/command/MoveCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/MoveCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/MoveCommand.java	(revision 2512)
@@ -54,5 +54,4 @@
      */
     private List<OldState> oldState = new LinkedList<OldState>();
-
 
     public MoveCommand(OsmPrimitive osm, double x, double y) {
Index: trunk/src/org/openstreetmap/josm/command/PurgePrimitivesCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/PurgePrimitivesCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/PurgePrimitivesCommand.java	(revision 2512)
@@ -65,5 +65,5 @@
      * constructor
      * @param primitive the primitive to purge
-     * 
+     *
      */
     public PurgePrimitivesCommand(OsmPrimitive primitive) {
@@ -75,5 +75,5 @@
      * @param layer the OSM data layer
      * @param primitive the primitive to purge
-     * 
+     *
      */
     public PurgePrimitivesCommand(OsmDataLayer layer, OsmPrimitive primitive) {
@@ -86,5 +86,5 @@
      * @param layer the OSM data layer
      * @param primitives the primitives to purge
-     * 
+     *
      */
     public PurgePrimitivesCommand(OsmDataLayer layer, Collection<OsmPrimitive> primitives) {
@@ -95,5 +95,5 @@
     /**
      * Replies a collection with the purged primitives
-     * 
+     *
      * @return a collection with the purged primitives
      */
@@ -235,5 +235,5 @@
      * Use to inject a backreference data set used when the command
      * is executed.
-     * 
+     *
      * @param ds the backreference data set
      */
Index: trunk/src/org/openstreetmap/josm/command/RelationMemberConflictResolverCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/RelationMemberConflictResolverCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/RelationMemberConflictResolverCommand.java	(revision 2512)
@@ -50,5 +50,4 @@
         this.mergedMembers = mergedMembers;
     }
-
 
     @Override
Index: trunk/src/org/openstreetmap/josm/command/TagConflictResolveCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/TagConflictResolveCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/TagConflictResolveCommand.java	(revision 2512)
@@ -27,5 +27,4 @@
     private static final Logger logger = Logger.getLogger(TagConflictResolveCommand.class.getName());
 
-
     /** the conflict to resolve */
     private Conflict<OsmPrimitive> conflict;
@@ -34,8 +33,7 @@
     private final List<TagMergeItem> mergeItems;
 
-
     /**
      * replies the number of decided conflicts
-     * 
+     *
      * @return the number of decided conflicts
      */
@@ -52,5 +50,5 @@
     /**
      * constructor
-     * 
+     *
      * @param my  my primitive
      * @param their  their primitive
@@ -61,5 +59,4 @@
         this.mergeItems = mergeItems;
     }
-
 
     @Override
Index: trunk/src/org/openstreetmap/josm/command/UndeletePrimitivesCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/UndeletePrimitivesCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/UndeletePrimitivesCommand.java	(revision 2512)
@@ -55,5 +55,4 @@
     }
 
-
     @Override
     public MutableTreeNode description() {
Index: trunk/src/org/openstreetmap/josm/command/VersionConflictResolveCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/VersionConflictResolveCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/VersionConflictResolveCommand.java	(revision 2512)
Index: trunk/src/org/openstreetmap/josm/command/WayNodesConflictResolverCommand.java
===================================================================
--- trunk/src/org/openstreetmap/josm/command/WayNodesConflictResolverCommand.java	(revision 2495)
+++ trunk/src/org/openstreetmap/josm/command/WayNodesConflictResolverCommand.java	(revision 2512)
@@ -35,5 +35,4 @@
     private final List<Node> mergedNodeList;
 
-
     /**
      *
@@ -46,5 +45,4 @@
         this.mergedNodeList = mergedNodeList;
     }
-
 
     @Override