Index: trunk/test/functional/org/openstreetmap/josm/io/MultiFetchServerObjectReaderTest.java
===================================================================
--- trunk/test/functional/org/openstreetmap/josm/io/MultiFetchServerObjectReaderTest.java	(revision 2578)
+++ trunk/test/functional/org/openstreetmap/josm/io/MultiFetchServerObjectReaderTest.java	(revision 2600)
@@ -32,4 +32,5 @@
 import org.openstreetmap.josm.data.osm.Way;
 import org.openstreetmap.josm.data.projection.Mercator;
+import org.openstreetmap.josm.gui.io.UploadStrategy;
 import org.openstreetmap.josm.gui.io.UploadStrategySpecification;
 import org.openstreetmap.josm.gui.progress.NullProgressMonitor;
@@ -125,5 +126,5 @@
         OsmServerWriter writer = new OsmServerWriter();
         Changeset cs = new Changeset();
-        writer.uploadOsm(UploadStrategySpecification.createSingleRequestUploadStrategy(), primitives,cs,NullProgressMonitor.INSTANCE);
+        writer.uploadOsm(new UploadStrategySpecification().setStrategy(UploadStrategy.SINGLE_REQUEST_STRATEGY), primitives,cs,NullProgressMonitor.INSTANCE);
         OsmApi.getOsmApi().closeChangeset(cs, NullProgressMonitor.INSTANCE);
     }
Index: trunk/test/functional/org/openstreetmap/josm/io/OsmServerBackreferenceReaderTest.java
===================================================================
--- trunk/test/functional/org/openstreetmap/josm/io/OsmServerBackreferenceReaderTest.java	(revision 2578)
+++ trunk/test/functional/org/openstreetmap/josm/io/OsmServerBackreferenceReaderTest.java	(revision 2600)
@@ -33,4 +33,5 @@
 import org.openstreetmap.josm.data.osm.Way;
 import org.openstreetmap.josm.data.projection.Mercator;
+import org.openstreetmap.josm.gui.io.UploadStrategy;
 import org.openstreetmap.josm.gui.io.UploadStrategySpecification;
 import org.openstreetmap.josm.gui.progress.NullProgressMonitor;
@@ -129,5 +130,5 @@
         OsmServerWriter writer = new OsmServerWriter();
         Changeset cs  = new Changeset();
-        writer.uploadOsm(UploadStrategySpecification.createSingleRequestUploadStrategy(), primitives, cs, NullProgressMonitor.INSTANCE);
+        writer.uploadOsm(new UploadStrategySpecification().setStrategy(UploadStrategy.SINGLE_REQUEST_STRATEGY), primitives, cs, NullProgressMonitor.INSTANCE);
         OsmApi.getOsmApi().closeChangeset(cs, NullProgressMonitor.INSTANCE);
     }
Index: trunk/test/functional/org/openstreetmap/josm/io/UploadStrategySelectionPanelTest.java
===================================================================
--- trunk/test/functional/org/openstreetmap/josm/io/UploadStrategySelectionPanelTest.java	(revision 2578)
+++ trunk/test/functional/org/openstreetmap/josm/io/UploadStrategySelectionPanelTest.java	(revision 2600)
@@ -3,26 +3,59 @@
 
 import java.awt.BorderLayout;
+import java.awt.FlowLayout;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
 
 import javax.swing.JFrame;
+import javax.swing.JLabel;
+import javax.swing.JPanel;
+import javax.swing.JTextField;
 
+import org.openstreetmap.josm.fixtures.JOSMFixture;
 import org.openstreetmap.josm.gui.io.UploadStrategySelectionPanel;
+import org.openstreetmap.josm.gui.progress.NullProgressMonitor;
 
 public class UploadStrategySelectionPanelTest extends JFrame {
 
-    private UploadStrategySelectionPanel pnl;
+    private UploadStrategySelectionPanel uploadStrategySelectionPanel;
 
     protected void build()  {
         getContentPane().setLayout(new BorderLayout());
-        pnl = new UploadStrategySelectionPanel();
-        getContentPane().add(pnl, BorderLayout.CENTER);
+        uploadStrategySelectionPanel = new UploadStrategySelectionPanel();
+        getContentPane().add(uploadStrategySelectionPanel, BorderLayout.CENTER);
+        getContentPane().add(buildControlPanel(), BorderLayout.SOUTH);
         setSize(400,400);
     }
 
+
+    protected JPanel buildControlPanel() {
+        JPanel pnl = new JPanel(new FlowLayout(FlowLayout.LEFT));
+        pnl.add(new JLabel("Num objects:"));
+        final JTextField tf;
+        pnl.add(tf = new JTextField(8));
+        tf.addActionListener(
+                new ActionListener() {
+                    public void actionPerformed(ActionEvent arg0) {
+                        int n = 0;
+                        try {
+                            n = Integer.parseInt(tf.getText());
+                        } catch(NumberFormatException e) {
+                            e.printStackTrace();
+                            return;
+                        }
+                        uploadStrategySelectionPanel.setNumUploadedObjects(n);
+                    }
+                }
+        );
+        return pnl;
+    }
     public UploadStrategySelectionPanelTest() {
         build();
-        pnl.setNumUploadedObjects(1500);
+        uploadStrategySelectionPanel.setNumUploadedObjects(51000);
     }
 
-    public static void main(String args[]) {
+    public static void main(String args[]) throws OsmApiInitializationException {
+        JOSMFixture josmFixture = JOSMFixture.createFunctionalTestFixture();
+        OsmApi.getOsmApi().initialize(NullProgressMonitor.INSTANCE);
         new UploadStrategySelectionPanelTest().setVisible(true);
     }